package com.sun.media.sound;

import javax.sound.sampled.AudioFormat;
import java.util.Random;
import javax.sound.midi.Patch;

public final class EmergencySoundbank
{
    private static final String[] general_midi_instruments;
    
    public EmergencySoundbank() {
    }
    
    public static SF2Soundbank createSoundbank() throws Exception {
        SF2Soundbank sf2Soundbank = new SF2Soundbank();
        sf2Soundbank.setName("Emergency GM sound set");
        sf2Soundbank.setVendor("Generated");
        sf2Soundbank.setDescription("Emergency generated soundbank");
        SF2Layer new_bass_drum = new_bass_drum(sf2Soundbank);
        SF2Layer new_snare_drum = new_snare_drum(sf2Soundbank);
        SF2Layer new_tom = new_tom(sf2Soundbank);
        SF2Layer new_open_hihat = new_open_hihat(sf2Soundbank);
        SF2Layer new_closed_hihat = new_closed_hihat(sf2Soundbank);
        SF2Layer new_crash_cymbal = new_crash_cymbal(sf2Soundbank);
        SF2Layer new_side_stick = new_side_stick(sf2Soundbank);
        SF2Layer[] array = new SF2Layer[128];
        array[36] = (array[35] = new_bass_drum);
        array[40] = (array[38] = new_snare_drum);
        array[43] = (array[41] = new_tom);
        array[47] = (array[45] = new_tom);
        array[50] = (array[48] = new_tom);
        array[44] = (array[42] = new_closed_hihat);
        array[46] = new_open_hihat;
        array[51] = (array[49] = new_crash_cymbal);
        array[55] = (array[52] = new_crash_cymbal);
        array[59] = (array[57] = new_crash_cymbal);
        array[39] = (array[37] = new_side_stick);
        array[54] = (array[53] = new_side_stick);
        array[58] = (array[56] = new_side_stick);
        array[70] = (array[69] = new_side_stick);
        array[60] = (array[75] = new_side_stick);
        array[62] = (array[61] = new_side_stick);
        array[64] = (array[63] = new_side_stick);
        array[66] = (array[65] = new_side_stick);
        array[68] = (array[67] = new_side_stick);
        array[72] = (array[71] = new_side_stick);
        array[74] = (array[73] = new_side_stick);
        array[77] = (array[76] = new_side_stick);
        array[79] = (array[78] = new_side_stick);
        array[81] = (array[80] = new_side_stick);
        SF2Instrument sf2Instrument = new SF2Instrument(sf2Soundbank);
        sf2Instrument.setName("Standard Kit");
        sf2Instrument.setPatch(new ModelPatch(0, 0, true));
        sf2Soundbank.addInstrument(sf2Instrument);
        for (int i = 0; i < array.length; ++i) {
            if (array[i] != null) {
                SF2InstrumentRegion o = new SF2InstrumentRegion();
                o.setLayer(array[i]);
                o.putBytes(43, new byte[] { (byte)i, (byte)i });
                sf2Instrument.getRegions().add(o);
            }
        }
        SF2Layer new_gpiano = new_gpiano(sf2Soundbank);
        SF2Layer new_gpiano2 = new_gpiano2(sf2Soundbank);
        SF2Layer new_piano_hammer = new_piano_hammer(sf2Soundbank);
        SF2Layer new_piano1 = new_piano1(sf2Soundbank);
        SF2Layer new_epiano1 = new_epiano1(sf2Soundbank);
        SF2Layer new_epiano2 = new_epiano2(sf2Soundbank);
        SF2Layer new_guitar1 = new_guitar1(sf2Soundbank);
        SF2Layer new_guitar_pick = new_guitar_pick(sf2Soundbank);
        SF2Layer new_guitar_dist = new_guitar_dist(sf2Soundbank);
        SF2Layer new_bass1 = new_bass1(sf2Soundbank);
        SF2Layer new_bass2 = new_bass2(sf2Soundbank);
        SF2Layer new_synthbass = new_synthbass(sf2Soundbank);
        SF2Layer new_string2 = new_string2(sf2Soundbank);
        SF2Layer new_orchhit = new_orchhit(sf2Soundbank);
        SF2Layer new_choir = new_choir(sf2Soundbank);
        SF2Layer new_solostring = new_solostring(sf2Soundbank);
        SF2Layer new_organ = new_organ(sf2Soundbank);
        SF2Layer new_ch_organ = new_ch_organ(sf2Soundbank);
        SF2Layer new_bell = new_bell(sf2Soundbank);
        SF2Layer new_flute = new_flute(sf2Soundbank);
        SF2Layer new_timpani = new_timpani(sf2Soundbank);
        SF2Layer new_melodic_toms = new_melodic_toms(sf2Soundbank);
        SF2Layer new_trumpet = new_trumpet(sf2Soundbank);
        SF2Layer new_trombone = new_trombone(sf2Soundbank);
        SF2Layer new_brass_section = new_brass_section(sf2Soundbank);
        SF2Layer new_horn = new_horn(sf2Soundbank);
        SF2Layer new_sax = new_sax(sf2Soundbank);
        SF2Layer new_oboe = new_oboe(sf2Soundbank);
        SF2Layer new_bassoon = new_bassoon(sf2Soundbank);
        SF2Layer new_clarinet = new_clarinet(sf2Soundbank);
        SF2Layer new_reverse_cymbal = new_reverse_cymbal(sf2Soundbank);
        newInstrument(sf2Soundbank, "Piano", new Patch(0, 0), new SF2Layer[] { new_gpiano, new_piano_hammer });
        newInstrument(sf2Soundbank, "Piano", new Patch(0, 1), new SF2Layer[] { new_gpiano2, new_piano_hammer });
        newInstrument(sf2Soundbank, "Piano", new Patch(0, 2), new SF2Layer[] { new_piano1 });
        SF2Instrument instrument = newInstrument(sf2Soundbank, "Honky-tonk Piano", new Patch(0, 3), new SF2Layer[] { new_piano1, new_piano1 });
        SF2InstrumentRegion sf2InstrumentRegion = (SF2InstrumentRegion)instrument.getRegions().get(0);
        sf2InstrumentRegion.putInteger(8, 80);
        sf2InstrumentRegion.putInteger(52, 30);
        ((SF2InstrumentRegion)instrument.getRegions().get(1)).putInteger(8, 30);
        newInstrument(sf2Soundbank, "Rhodes", new Patch(0, 4), new SF2Layer[] { new_epiano2 });
        newInstrument(sf2Soundbank, "Rhodes", new Patch(0, 5), new SF2Layer[] { new_epiano2 });
        newInstrument(sf2Soundbank, "Clavinet", new Patch(0, 6), new SF2Layer[] { new_epiano1 });
        newInstrument(sf2Soundbank, "Clavinet", new Patch(0, 7), new SF2Layer[] { new_epiano1 });
        newInstrument(sf2Soundbank, "Rhodes", new Patch(0, 8), new SF2Layer[] { new_epiano2 });
        newInstrument(sf2Soundbank, "Bell", new Patch(0, 9), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Bell", new Patch(0, 10), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Vibraphone", new Patch(0, 11), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Marimba", new Patch(0, 12), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Marimba", new Patch(0, 13), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Bell", new Patch(0, 14), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Rock Organ", new Patch(0, 15), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Rock Organ", new Patch(0, 16), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Perc Organ", new Patch(0, 17), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Rock Organ", new Patch(0, 18), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Church Organ", new Patch(0, 19), new SF2Layer[] { new_ch_organ });
        newInstrument(sf2Soundbank, "Accordion", new Patch(0, 20), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Accordion", new Patch(0, 21), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Accordion", new Patch(0, 22), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Accordion", new Patch(0, 23), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 24), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 25), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 26), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 27), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 28), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Distorted Guitar", new Patch(0, 29), new SF2Layer[] { new_guitar_dist });
        newInstrument(sf2Soundbank, "Distorted Guitar", new Patch(0, 30), new SF2Layer[] { new_guitar_dist });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 31), new SF2Layer[] { new_guitar1, new_guitar_pick });
        newInstrument(sf2Soundbank, "Finger Bass", new Patch(0, 32), new SF2Layer[] { new_bass1 });
        newInstrument(sf2Soundbank, "Finger Bass", new Patch(0, 33), new SF2Layer[] { new_bass1 });
        newInstrument(sf2Soundbank, "Finger Bass", new Patch(0, 34), new SF2Layer[] { new_bass1 });
        newInstrument(sf2Soundbank, "Frettless Bass", new Patch(0, 35), new SF2Layer[] { new_bass2 });
        newInstrument(sf2Soundbank, "Frettless Bass", new Patch(0, 36), new SF2Layer[] { new_bass2 });
        newInstrument(sf2Soundbank, "Frettless Bass", new Patch(0, 37), new SF2Layer[] { new_bass2 });
        newInstrument(sf2Soundbank, "Synth Bass1", new Patch(0, 38), new SF2Layer[] { new_synthbass });
        newInstrument(sf2Soundbank, "Synth Bass2", new Patch(0, 39), new SF2Layer[] { new_synthbass });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 40), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 41), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 42), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 43), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 44), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 45), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Harp", new Patch(0, 46), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Timpani", new Patch(0, 47), new SF2Layer[] { new_timpani });
        newInstrument(sf2Soundbank, "Strings", new Patch(0, 48), new SF2Layer[] { new_string2 });
        SF2InstrumentRegion sf2InstrumentRegion2 = (SF2InstrumentRegion)newInstrument(sf2Soundbank, "Slow Strings", new Patch(0, 49), new SF2Layer[] { new_string2 }).getRegions().get(0);
        sf2InstrumentRegion2.putInteger(34, 2500);
        sf2InstrumentRegion2.putInteger(38, 2000);
        newInstrument(sf2Soundbank, "Synth Strings", new Patch(0, 50), new SF2Layer[] { new_string2 });
        newInstrument(sf2Soundbank, "Synth Strings", new Patch(0, 51), new SF2Layer[] { new_string2 });
        newInstrument(sf2Soundbank, "Choir", new Patch(0, 52), new SF2Layer[] { new_choir });
        newInstrument(sf2Soundbank, "Choir", new Patch(0, 53), new SF2Layer[] { new_choir });
        newInstrument(sf2Soundbank, "Choir", new Patch(0, 54), new SF2Layer[] { new_choir });
        SF2InstrumentRegion sf2InstrumentRegion3 = (SF2InstrumentRegion)newInstrument(sf2Soundbank, "Orch Hit", new Patch(0, 55), new SF2Layer[] { new_orchhit, new_orchhit, new_timpani }).getRegions().get(0);
        sf2InstrumentRegion3.putInteger(51, -12);
        sf2InstrumentRegion3.putInteger(48, -100);
        newInstrument(sf2Soundbank, "Trumpet", new Patch(0, 56), new SF2Layer[] { new_trumpet });
        newInstrument(sf2Soundbank, "Trombone", new Patch(0, 57), new SF2Layer[] { new_trombone });
        newInstrument(sf2Soundbank, "Trombone", new Patch(0, 58), new SF2Layer[] { new_trombone });
        newInstrument(sf2Soundbank, "Trumpet", new Patch(0, 59), new SF2Layer[] { new_trumpet });
        newInstrument(sf2Soundbank, "Horn", new Patch(0, 60), new SF2Layer[] { new_horn });
        newInstrument(sf2Soundbank, "Brass Section", new Patch(0, 61), new SF2Layer[] { new_brass_section });
        newInstrument(sf2Soundbank, "Brass Section", new Patch(0, 62), new SF2Layer[] { new_brass_section });
        newInstrument(sf2Soundbank, "Brass Section", new Patch(0, 63), new SF2Layer[] { new_brass_section });
        newInstrument(sf2Soundbank, "Sax", new Patch(0, 64), new SF2Layer[] { new_sax });
        newInstrument(sf2Soundbank, "Sax", new Patch(0, 65), new SF2Layer[] { new_sax });
        newInstrument(sf2Soundbank, "Sax", new Patch(0, 66), new SF2Layer[] { new_sax });
        newInstrument(sf2Soundbank, "Sax", new Patch(0, 67), new SF2Layer[] { new_sax });
        newInstrument(sf2Soundbank, "Oboe", new Patch(0, 68), new SF2Layer[] { new_oboe });
        newInstrument(sf2Soundbank, "Horn", new Patch(0, 69), new SF2Layer[] { new_horn });
        newInstrument(sf2Soundbank, "Bassoon", new Patch(0, 70), new SF2Layer[] { new_bassoon });
        newInstrument(sf2Soundbank, "Clarinet", new Patch(0, 71), new SF2Layer[] { new_clarinet });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 72), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 73), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 74), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 75), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 76), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 77), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 78), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 79), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 80), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 81), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Flute", new Patch(0, 82), new SF2Layer[] { new_flute });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 83), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 84), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Choir", new Patch(0, 85), new SF2Layer[] { new_choir });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 86), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 87), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Synth Strings", new Patch(0, 88), new SF2Layer[] { new_string2 });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 89), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 90), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Choir", new Patch(0, 91), new SF2Layer[] { new_choir });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 92), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 93), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 94), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 95), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 96), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 97), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Bell", new Patch(0, 98), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 99), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 100), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Organ", new Patch(0, 101), new SF2Layer[] { new_organ });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 102), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Synth Strings", new Patch(0, 103), new SF2Layer[] { new_string2 });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 104), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 105), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 106), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 107), new SF2Layer[] { new_piano1 });
        newInstrument(sf2Soundbank, "Marimba", new Patch(0, 108), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Sax", new Patch(0, 109), new SF2Layer[] { new_sax });
        newInstrument(sf2Soundbank, "Solo String", new Patch(0, 110), new SF2Layer[] { new_string2, new_solostring });
        newInstrument(sf2Soundbank, "Oboe", new Patch(0, 111), new SF2Layer[] { new_oboe });
        newInstrument(sf2Soundbank, "Bell", new Patch(0, 112), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Melodic Toms", new Patch(0, 113), new SF2Layer[] { new_melodic_toms });
        newInstrument(sf2Soundbank, "Marimba", new Patch(0, 114), new SF2Layer[] { new_bell });
        newInstrument(sf2Soundbank, "Melodic Toms", new Patch(0, 115), new SF2Layer[] { new_melodic_toms });
        newInstrument(sf2Soundbank, "Melodic Toms", new Patch(0, 116), new SF2Layer[] { new_melodic_toms });
        newInstrument(sf2Soundbank, "Melodic Toms", new Patch(0, 117), new SF2Layer[] { new_melodic_toms });
        newInstrument(sf2Soundbank, "Reverse Cymbal", new Patch(0, 118), new SF2Layer[] { new_reverse_cymbal });
        newInstrument(sf2Soundbank, "Reverse Cymbal", new Patch(0, 119), new SF2Layer[] { new_reverse_cymbal });
        newInstrument(sf2Soundbank, "Guitar", new Patch(0, 120), new SF2Layer[] { new_guitar1 });
        newInstrument(sf2Soundbank, "Def", new Patch(0, 121), new SF2Layer[] { new_piano1 });
        SF2InstrumentRegion sf2InstrumentRegion4 = (SF2InstrumentRegion)newInstrument(sf2Soundbank, "Seashore/Reverse Cymbal", new Patch(0, 122), new SF2Layer[] { new_reverse_cymbal }).getRegions().get(0);
        sf2InstrumentRegion4.putInteger(37, 1000);
        sf2InstrumentRegion4.putInteger(36, 18500);
        sf2InstrumentRegion4.putInteger(38, 4500);
        sf2InstrumentRegion4.putInteger(8, -4500);
        SF2InstrumentRegion sf2InstrumentRegion5 = (SF2InstrumentRegion)newInstrument(sf2Soundbank, "Bird/Flute", new Patch(0, 123), new SF2Layer[] { new_flute }).getRegions().get(0);
        sf2InstrumentRegion5.putInteger(51, 24);
        sf2InstrumentRegion5.putInteger(36, -3000);
        sf2InstrumentRegion5.putInteger(37, 1000);
        newInstrument(sf2Soundbank, "Def", new Patch(0, 124), new SF2Layer[] { new_side_stick });
        SF2InstrumentRegion sf2InstrumentRegion6 = (SF2InstrumentRegion)newInstrument(sf2Soundbank, "Seashore/Reverse Cymbal", new Patch(0, 125), new SF2Layer[] { new_reverse_cymbal }).getRegions().get(0);
        sf2InstrumentRegion6.putInteger(37, 1000);
        sf2InstrumentRegion6.putInteger(36, 18500);
        sf2InstrumentRegion6.putInteger(38, 4500);
        sf2InstrumentRegion6.putInteger(8, -4500);
        newInstrument(sf2Soundbank, "Applause/crash_cymbal", new Patch(0, 126), new SF2Layer[] { new_crash_cymbal });
        newInstrument(sf2Soundbank, "Gunshot/side_stick", new Patch(0, 127), new SF2Layer[] { new_side_stick });
        for (SF2Instrument sf2Instrument2 : sf2Soundbank.getInstruments()) {
            Patch patch = sf2Instrument2.getPatch();
            if (!(patch instanceof ModelPatch) || !((ModelPatch)patch).isPercussion()) {
                sf2Instrument2.setName(EmergencySoundbank.general_midi_instruments[patch.getProgram()]);
            }
        }
        return sf2Soundbank;
    }
    
    public static SF2Layer new_bell(SF2Soundbank sf2Soundbank) {
        Random random = new Random(102030201L);
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.01;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 1.0E-5;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 40; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1) * (1.0 + (random.nextDouble() * 2.0 - 1.0) * 0.01), n3 + (n4 - n3) * ((double)i / 40.0), n5);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "EPiano", newSimpleFFTSample(sf2Soundbank, "EPiano", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, 1200);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -9000);
        sf2Region.putInteger(8, 16000);
        return layer;
    }
    
    public static SF2Layer new_guitar1(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.01;
        double n4 = 0.01;
        double n5 = 2.0;
        double n6 = 0.01;
        double pow = Math.pow(n6 / n5, 0.025);
        double[] array2 = new double[40];
        for (int i = 0; i < 40; ++i) {
            array2[i] = n5;
            n5 *= pow;
        }
        array2[0] = 2.0;
        array2[1] = 0.5;
        array2[2] = 0.45;
        array2[3] = 0.2;
        array2[4] = 1.0;
        array2[5] = 0.5;
        array2[6] = 2.0;
        array2[7] = 1.0;
        array2[8] = 0.5;
        array2[9] = 1.0;
        array2[9] = 0.5;
        array2[10] = 0.2;
        array2[11] = 1.0;
        array2[12] = 0.7;
        array2[13] = 0.5;
        array2[14] = 1.0;
        for (int j = 0; j < 40; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Guitar", newSimpleFFTSample(sf2Soundbank, "Guitar", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 2400);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -100);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -6000);
        sf2Region.putInteger(8, 16000);
        sf2Region.putInteger(48, -20);
        return layer;
    }
    
    public static SF2Layer new_guitar_dist(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.01;
        double n4 = 0.01;
        double n5 = 2.0;
        double n6 = 0.01;
        double pow = Math.pow(n6 / n5, 0.025);
        double[] array2 = new double[40];
        for (int i = 0; i < 40; ++i) {
            array2[i] = n5;
            n5 *= pow;
        }
        array2[0] = 5.0;
        array2[1] = 2.0;
        array2[2] = 0.45;
        array2[3] = 0.2;
        array2[4] = 1.0;
        array2[5] = 0.5;
        array2[6] = 2.0;
        array2[7] = 1.0;
        array2[8] = 0.5;
        array2[9] = 1.0;
        array2[9] = 0.5;
        array2[10] = 0.2;
        array2[11] = 1.0;
        array2[12] = 0.7;
        array2[13] = 0.5;
        array2[14] = 1.0;
        for (int j = 0; j < 40; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Distorted Guitar", newSimpleFFTSample_dist(sf2Soundbank, "Distorted Guitar", array, n2, 10000.0));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(8, 8000);
        return layer;
    }
    
    public static SF2Layer new_guitar_pick(SF2Soundbank sf2Soundbank) {
        int n = 2;
        int n2 = 4096 * n;
        double[] array = new double[2 * n2];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5);
        }
        fft(array);
        for (int j = n2 / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 0; k < 2048 * n; ++k) {
            int n3 = k;
            array[n3] *= Math.exp(-Math.abs((double)(k - 23) / (double)n) * 1.2) + Math.exp(-Math.abs((double)(k - 40) / (double)n) * 0.9);
        }
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.8);
        double[] realPart = realPart(array);
        double n4 = 1.0;
        for (int l = 0; l < realPart.length; ++l) {
            int n5 = l;
            realPart[n5] *= n4;
            n4 *= 0.9994;
        }
        fadeUp(realPart, 80);
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Guitar Noise", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Guitar Noise");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_gpiano(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.2;
        double n4 = 0.001;
        double pow = Math.pow(n4 / n3, 0.06666666666666667);
        double[] array2 = new double[30];
        for (int i = 0; i < 30; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 2.0;
        int n6 = 4;
        array2[n6] *= 2.0;
        int n7 = 12;
        array2[n7] *= 0.9;
        int n8 = 13;
        array2[n8] *= 0.7;
        for (int j = 14; j < 30; ++j) {
            int n9 = j;
            array2[n9] *= 0.5;
        }
        for (int k = 0; k < 30; ++k) {
            double n10 = 0.2;
            double n11 = array2[k];
            if (k > 10) {
                n10 = 5.0;
                n11 *= 10.0;
            }
            int n12 = 0;
            if (k > 5) {
                n12 = (k - 5) * 7;
            }
            complexGaussianDist(array, n2 * (double)(k + 1) + (double)n12, n10, n11);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Grand Piano", newSimpleFFTSample(sf2Soundbank, "Grand Piano", array, n2, 200));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -7000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -6000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -5500);
        sf2Region.putInteger(8, 18000);
        return layer;
    }
    
    public static SF2Layer new_gpiano2(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.2;
        double n4 = 0.001;
        double pow = Math.pow(n4 / n3, 0.05);
        double[] array2 = new double[30];
        for (int i = 0; i < 30; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 1.0;
        int n6 = 4;
        array2[n6] *= 2.0;
        int n7 = 12;
        array2[n7] *= 0.9;
        int n8 = 13;
        array2[n8] *= 0.7;
        for (int j = 14; j < 30; ++j) {
            int n9 = j;
            array2[n9] *= 0.5;
        }
        for (int k = 0; k < 30; ++k) {
            double n10 = 0.2;
            double n11 = array2[k];
            if (k > 10) {
                n10 = 5.0;
                n11 *= 10.0;
            }
            int n12 = 0;
            if (k > 5) {
                n12 = (k - 5) * 7;
            }
            complexGaussianDist(array, n2 * (double)(k + 1) + (double)n12, n10, n11);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Grand Piano", newSimpleFFTSample(sf2Soundbank, "Grand Piano", array, n2, 200));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -7000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -6000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -5500);
        sf2Region.putInteger(8, 18000);
        return layer;
    }
    
    public static SF2Layer new_piano_hammer(SF2Soundbank sf2Soundbank) {
        int n = 2;
        int n2 = 4096 * n;
        double[] array = new double[2 * n2];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5);
        }
        fft(array);
        for (int j = n2 / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 0; k < 2048 * n; ++k) {
            int n3 = k;
            array[n3] *= Math.exp(-Math.abs((double)(k - 37) / (double)n) * 0.05);
        }
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.6);
        double[] realPart = realPart(array);
        double n4 = 1.0;
        for (int l = 0; l < realPart.length; ++l) {
            int n5 = l;
            realPart[n5] *= n4;
            n4 *= 0.9997;
        }
        fadeUp(realPart, 80);
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Piano Hammer", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Piano Hammer");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_piano1(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.2;
        double n4 = 1.0E-4;
        double pow = Math.pow(n4 / n3, 0.025);
        double[] array2 = new double[30];
        for (int i = 0; i < 30; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 5.0;
        int n6 = 2;
        array2[n6] *= 0.1;
        int n7 = 7;
        array2[n7] *= 5.0;
        for (int j = 0; j < 30; ++j) {
            double n8 = 0.2;
            double n9 = array2[j];
            if (j > 12) {
                n8 = 5.0;
                n9 *= 10.0;
            }
            int n10 = 0;
            if (j > 5) {
                n10 = (j - 5) * 7;
            }
            complexGaussianDist(array, n2 * (double)(j + 1) + (double)n10, n8, n9);
        }
        complexGaussianDist(array, n2 * 15.5, 1.0, 0.1);
        complexGaussianDist(array, n2 * 17.5, 1.0, 0.01);
        SF2Layer layer = newLayer(sf2Soundbank, "EPiano", newSimpleFFTSample(sf2Soundbank, "EPiano", array, n2, 200));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -1200);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -5500);
        sf2Region.putInteger(8, 16000);
        return layer;
    }
    
    public static SF2Layer new_epiano1(SF2Soundbank sf2Soundbank) {
        Random random = new Random(302030201L);
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.05;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 1.0E-4;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 40; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1) * (1.0 + (random.nextDouble() * 2.0 - 1.0) * 1.0E-4), n3 + (n4 - n3) * ((double)i / 40.0), n5);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "EPiano", newSimpleFFTSample(sf2Soundbank, "EPiano", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, 1200);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -9000);
        sf2Region.putInteger(8, 16000);
        return layer;
    }
    
    public static SF2Layer new_epiano2(SF2Soundbank sf2Soundbank) {
        Random random = new Random(302030201L);
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.01;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 1.0E-5;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 40; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1) * (1.0 + (random.nextDouble() * 2.0 - 1.0) * 1.0E-4), n3 + (n4 - n3) * ((double)i / 40.0), n5);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "EPiano", newSimpleFFTSample(sf2Soundbank, "EPiano", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 8000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, 2400);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -9000);
        sf2Region.putInteger(8, 16000);
        sf2Region.putInteger(48, -100);
        return layer;
    }
    
    public static SF2Layer new_bass1(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.05;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 0.02;
        double pow = Math.pow(n6 / n5, 0.04);
        double[] array2 = new double[25];
        for (int i = 0; i < 25; ++i) {
            array2[i] = n5;
            n5 *= pow;
        }
        int n7 = 0;
        array2[n7] *= 8.0;
        int n8 = 1;
        array2[n8] *= 4.0;
        int n9 = 3;
        array2[n9] *= 8.0;
        int n10 = 5;
        array2[n10] *= 8.0;
        for (int j = 0; j < 25; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Bass", newSimpleFFTSample(sf2Soundbank, "Bass", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -3000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -5000);
        sf2Region.putInteger(8, 11000);
        sf2Region.putInteger(48, -100);
        return layer;
    }
    
    public static SF2Layer new_synthbass(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.05;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 0.02;
        double pow = Math.pow(n6 / n5, 0.04);
        double[] array2 = new double[25];
        for (int i = 0; i < 25; ++i) {
            array2[i] = n5;
            n5 *= pow;
        }
        int n7 = 0;
        array2[n7] *= 16.0;
        int n8 = 1;
        array2[n8] *= 4.0;
        int n9 = 3;
        array2[n9] *= 16.0;
        int n10 = 5;
        array2[n10] *= 8.0;
        for (int j = 0; j < 25; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Bass", newSimpleFFTSample(sf2Soundbank, "Bass", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -12000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -3000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, -3000);
        sf2Region.putInteger(9, 100);
        sf2Region.putInteger(8, 8000);
        sf2Region.putInteger(48, -100);
        return layer;
    }
    
    public static SF2Layer new_bass2(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 0.05;
        double n4 = 0.05;
        double n5 = 0.2;
        double n6 = 0.002;
        double pow = Math.pow(n6 / n5, 0.04);
        double[] array2 = new double[25];
        for (int i = 0; i < 25; ++i) {
            array2[i] = n5;
            n5 *= pow;
        }
        int n7 = 0;
        array2[n7] *= 8.0;
        int n8 = 1;
        array2[n8] *= 4.0;
        int n9 = 3;
        array2[n9] *= 8.0;
        int n10 = 5;
        array2[n10] *= 8.0;
        for (int j = 0; j < 25; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Bass2", newSimpleFFTSample(sf2Soundbank, "Bass2", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -8000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(26, -6000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(8, 5000);
        sf2Region.putInteger(48, -100);
        return layer;
    }
    
    public static SF2Layer new_solostring(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 2.0;
        double n4 = 2.0;
        double n5 = 0.2;
        double n6 = 0.01;
        double[] array2 = new double[18];
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < array2.length; ++i) {
            n5 *= pow;
            array2[i] = n5;
        }
        int n7 = 0;
        array2[n7] *= 5.0;
        int n8 = 1;
        array2[n8] *= 5.0;
        int n9 = 2;
        array2[n9] *= 5.0;
        int n10 = 3;
        array2[n10] *= 4.0;
        int n11 = 4;
        array2[n11] *= 4.0;
        int n12 = 5;
        array2[n12] *= 3.0;
        int n13 = 6;
        array2[n13] *= 3.0;
        int n14 = 7;
        array2[n14] *= 2.0;
        for (int j = 0; j < array2.length; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), n5);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Strings", newSimpleFFTSample(sf2Soundbank, "Strings", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -5000);
        sf2Region.putInteger(38, 1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        sf2Region.putInteger(24, -1000);
        sf2Region.putInteger(6, 15);
        return layer;
    }
    
    public static SF2Layer new_orchhit(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 2.0;
        double n4 = 80.0;
        double n5 = 0.2;
        double n6 = 0.001;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 40; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1), n3 + (n4 - n3) * ((double)i / 40.0), n5);
        }
        complexGaussianDist(array, n2 * 4.0, 300.0, 1.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Och Strings", newSimpleFFTSample(sf2Soundbank, "Och Strings", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -5000);
        sf2Region.putInteger(38, 200);
        sf2Region.putInteger(36, 200);
        sf2Region.putInteger(37, 1000);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_string2(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 2.0;
        double n4 = 80.0;
        double n5 = 0.2;
        double n6 = 0.001;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 40; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1), n3 + (n4 - n3) * ((double)i / 40.0), n5);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Strings", newSimpleFFTSample(sf2Soundbank, "Strings", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -5000);
        sf2Region.putInteger(38, 1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_choir(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 25);
        double n3 = 2.0;
        double n4 = 80.0;
        double n5 = 0.2;
        double n6 = 0.001;
        double pow = Math.pow(n6 / n5, 0.025);
        double[] array2 = new double[40];
        for (int i = 0; i < array2.length; ++i) {
            n5 *= pow;
            array2[i] = n5;
        }
        int n7 = 5;
        array2[n7] *= 0.1;
        int n8 = 6;
        array2[n8] *= 0.01;
        int n9 = 7;
        array2[n9] *= 0.1;
        int n10 = 8;
        array2[n10] *= 0.1;
        for (int j = 0; j < array2.length; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Strings", newSimpleFFTSample(sf2Soundbank, "Strings", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -5000);
        sf2Region.putInteger(38, 1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_organ(SF2Soundbank sf2Soundbank) {
        Random random = new Random(102030201L);
        int n = 1;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.01;
        double n4 = 0.01;
        double n5 = 0.2;
        double n6 = 0.001;
        double pow = Math.pow(n6 / n5, 0.025);
        for (int i = 0; i < 12; n5 *= pow, ++i) {
            complexGaussianDist(array, n2 * (double)(i + 1), n3 + (n4 - n3) * ((double)i / 40.0), n5 * (0.5 + 3.0 * random.nextDouble()));
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Organ", newSimpleFFTSample(sf2Soundbank, "Organ", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_ch_organ(SF2Soundbank sf2Soundbank) {
        int n = 1;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.01;
        double n4 = 0.01;
        double n5 = 0.2;
        double n6 = 0.001;
        double n7 = n5;
        double pow = Math.pow(n6 / n5, 0.016666666666666666);
        double[] array2 = new double[60];
        for (int i = 0; i < array2.length; ++i) {
            n7 *= pow;
            array2[i] = n7;
        }
        int n8 = 0;
        array2[n8] *= 5.0;
        int n9 = 1;
        array2[n9] *= 2.0;
        array2[2] = 0.0;
        array2[5] = (array2[4] = 0.0);
        int n10 = 7;
        array2[n10] *= 7.0;
        array2[9] = 0.0;
        array2[12] = (array2[10] = 0.0);
        int n11 = 15;
        array2[n11] *= 7.0;
        array2[18] = 0.0;
        array2[24] = (array2[20] = 0.0);
        int n12 = 27;
        array2[n12] *= 5.0;
        array2[29] = 0.0;
        array2[33] = (array2[30] = 0.0);
        int n13 = 36;
        array2[n13] *= 4.0;
        array2[37] = 0.0;
        array2[42] = (array2[39] = 0.0);
        array2[47] = (array2[43] = 0.0);
        int n14 = 50;
        array2[n14] *= 4.0;
        array2[52] = 0.0;
        array2[57] = (array2[55] = 0.0);
        int n15 = 10;
        array2[n15] *= 0.1;
        int n16 = 11;
        array2[n16] *= 0.1;
        int n17 = 12;
        array2[n17] *= 0.1;
        int n18 = 13;
        array2[n18] *= 0.1;
        int n19 = 17;
        array2[n19] *= 0.1;
        int n20 = 18;
        array2[n20] *= 0.1;
        int n21 = 19;
        array2[n21] *= 0.1;
        int n22 = 20;
        array2[n22] *= 0.1;
        for (int j = 0; j < 60; n7 *= pow, ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), n3 + (n4 - n3) * ((double)j / 40.0), array2[j]);
        }
        SF2Layer layer = newLayer(sf2Soundbank, "Organ", newSimpleFFTSample(sf2Soundbank, "Organ", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -10000);
        sf2Region.putInteger(38, -1000);
        return layer;
    }
    
    public static SF2Layer new_flute(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        complexGaussianDist(array, n2 * 1.0, 0.001, 0.5);
        complexGaussianDist(array, n2 * 2.0, 0.001, 0.5);
        complexGaussianDist(array, n2 * 3.0, 0.001, 0.5);
        complexGaussianDist(array, n2 * 4.0, 0.01, 0.5);
        complexGaussianDist(array, n2 * 4.0, 100.0, 120.0);
        complexGaussianDist(array, n2 * 6.0, 100.0, 40.0);
        complexGaussianDist(array, n2 * 8.0, 100.0, 80.0);
        complexGaussianDist(array, n2 * 5.0, 0.001, 0.05);
        complexGaussianDist(array, n2 * 6.0, 0.001, 0.06);
        complexGaussianDist(array, n2 * 7.0, 0.001, 0.04);
        complexGaussianDist(array, n2 * 8.0, 0.005, 0.06);
        complexGaussianDist(array, n2 * 9.0, 0.005, 0.06);
        complexGaussianDist(array, n2 * 10.0, 0.01, 0.1);
        complexGaussianDist(array, n2 * 11.0, 0.08, 0.7);
        complexGaussianDist(array, n2 * 12.0, 0.08, 0.6);
        complexGaussianDist(array, n2 * 13.0, 0.08, 0.6);
        complexGaussianDist(array, n2 * 14.0, 0.08, 0.6);
        complexGaussianDist(array, n2 * 15.0, 0.08, 0.5);
        complexGaussianDist(array, n2 * 16.0, 0.08, 0.5);
        complexGaussianDist(array, n2 * 17.0, 0.08, 0.2);
        complexGaussianDist(array, n2 * 1.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 2.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 3.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 4.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 5.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 6.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 7.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 8.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 9.0, 20.0, 8.0);
        complexGaussianDist(array, n2 * 10.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 11.0, 30.0, 9.0);
        complexGaussianDist(array, n2 * 12.0, 30.0, 9.0);
        complexGaussianDist(array, n2 * 13.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 14.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 15.0, 30.0, 7.0);
        complexGaussianDist(array, n2 * 16.0, 30.0, 7.0);
        complexGaussianDist(array, n2 * 17.0, 30.0, 6.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Flute", newSimpleFFTSample(sf2Soundbank, "Flute", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_horn(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.5;
        double n4 = 1.0E-11;
        double pow = Math.pow(n4 / n3, 0.025);
        for (int i = 0; i < 40; n3 *= pow, ++i) {
            if (i == 0) {
                complexGaussianDist(array, n2 * (double)(i + 1), 0.1, n3 * 0.2);
            }
            else {
                complexGaussianDist(array, n2 * (double)(i + 1), 0.1, n3);
            }
        }
        complexGaussianDist(array, n2 * 2.0, 100.0, 1.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Horn", newSimpleFFTSample(sf2Soundbank, "Horn", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(26, -500);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, 5000);
        sf2Region.putInteger(8, 4500);
        return layer;
    }
    
    public static SF2Layer new_trumpet(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.5;
        double n4 = 1.0E-5;
        double pow = Math.pow(n4 / n3, 0.0125);
        double[] array2 = new double[80];
        for (int i = 0; i < 80; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 0.05;
        int n6 = 1;
        array2[n6] *= 0.2;
        int n7 = 2;
        array2[n7] *= 0.5;
        int n8 = 3;
        array2[n8] *= 0.85;
        for (int j = 0; j < 80; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), 0.1, array2[j]);
        }
        complexGaussianDist(array, n2 * 5.0, 300.0, 3.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Trumpet", newSimpleFFTSample(sf2Soundbank, "Trumpet", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -10000);
        sf2Region.putInteger(38, 0);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(26, -4000);
        sf2Region.putInteger(30, -2500);
        sf2Region.putInteger(11, 5000);
        sf2Region.putInteger(8, 4500);
        sf2Region.putInteger(9, 10);
        return layer;
    }
    
    public static SF2Layer new_brass_section(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.5;
        double n4 = 0.005;
        double pow = Math.pow(n4 / n3, 0.03333333333333333);
        double[] array2 = new double[30];
        for (int i = 0; i < 30; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 0.8;
        int n6 = 1;
        array2[n6] *= 0.9;
        double n7 = 5.0;
        for (int j = 0; j < 30; n7 += 6.0, ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), 0.1 * n7, array2[j] * n7);
        }
        complexGaussianDist(array, n2 * 6.0, 300.0, 2.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Brass Section", newSimpleFFTSample(sf2Soundbank, "Brass Section", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -9200);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(26, -3000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, 5000);
        sf2Region.putInteger(8, 4500);
        return layer;
    }
    
    public static SF2Layer new_trombone(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.5;
        double n4 = 0.001;
        double pow = Math.pow(n4 / n3, 0.0125);
        double[] array2 = new double[80];
        for (int i = 0; i < 80; ++i) {
            array2[i] = n3;
            n3 *= pow;
        }
        int n5 = 0;
        array2[n5] *= 0.3;
        int n6 = 1;
        array2[n6] *= 0.7;
        for (int j = 0; j < 80; ++j) {
            complexGaussianDist(array, n2 * (double)(j + 1), 0.1, array2[j]);
        }
        complexGaussianDist(array, n2 * 6.0, 300.0, 2.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Trombone", newSimpleFFTSample(sf2Soundbank, "Trombone", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -8000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(26, -2000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, 5000);
        sf2Region.putInteger(8, 4500);
        sf2Region.putInteger(9, 10);
        return layer;
    }
    
    public static SF2Layer new_sax(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        double n3 = 0.5;
        double n4 = 0.01;
        double pow = Math.pow(n4 / n3, 0.025);
        for (int i = 0; i < 40; n3 *= pow, ++i) {
            if (i == 0 || i == 2) {
                complexGaussianDist(array, n2 * (double)(i + 1), 0.1, n3 * 4.0);
            }
            else {
                complexGaussianDist(array, n2 * (double)(i + 1), 0.1, n3);
            }
        }
        complexGaussianDist(array, n2 * 4.0, 200.0, 1.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Sax", newSimpleFFTSample(sf2Soundbank, "Sax", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(26, -3000);
        sf2Region.putInteger(30, 12000);
        sf2Region.putInteger(11, 5000);
        sf2Region.putInteger(8, 4500);
        return layer;
    }
    
    public static SF2Layer new_oboe(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        complexGaussianDist(array, n2 * 5.0, 100.0, 80.0);
        complexGaussianDist(array, n2 * 1.0, 0.01, 0.53);
        complexGaussianDist(array, n2 * 2.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 3.0, 0.01, 0.48);
        complexGaussianDist(array, n2 * 4.0, 0.01, 0.49);
        complexGaussianDist(array, n2 * 5.0, 0.01, 5.0);
        complexGaussianDist(array, n2 * 6.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 7.0, 0.01, 0.5);
        complexGaussianDist(array, n2 * 8.0, 0.01, 0.59);
        complexGaussianDist(array, n2 * 9.0, 0.01, 0.61);
        complexGaussianDist(array, n2 * 10.0, 0.01, 0.52);
        complexGaussianDist(array, n2 * 11.0, 0.01, 0.49);
        complexGaussianDist(array, n2 * 12.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 13.0, 0.01, 0.48);
        complexGaussianDist(array, n2 * 14.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 15.0, 0.01, 0.46);
        complexGaussianDist(array, n2 * 16.0, 0.01, 0.35);
        complexGaussianDist(array, n2 * 17.0, 0.01, 0.2);
        complexGaussianDist(array, n2 * 18.0, 0.01, 0.1);
        complexGaussianDist(array, n2 * 19.0, 0.01, 0.5);
        complexGaussianDist(array, n2 * 20.0, 0.01, 0.1);
        SF2Layer layer = newLayer(sf2Soundbank, "Oboe", newSimpleFFTSample(sf2Soundbank, "Oboe", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_bassoon(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        complexGaussianDist(array, n2 * 2.0, 100.0, 40.0);
        complexGaussianDist(array, n2 * 4.0, 100.0, 20.0);
        complexGaussianDist(array, n2 * 1.0, 0.01, 0.53);
        complexGaussianDist(array, n2 * 2.0, 0.01, 5.0);
        complexGaussianDist(array, n2 * 3.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 4.0, 0.01, 0.48);
        complexGaussianDist(array, n2 * 5.0, 0.01, 1.49);
        complexGaussianDist(array, n2 * 6.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 7.0, 0.01, 0.5);
        complexGaussianDist(array, n2 * 8.0, 0.01, 0.59);
        complexGaussianDist(array, n2 * 9.0, 0.01, 0.61);
        complexGaussianDist(array, n2 * 10.0, 0.01, 0.52);
        complexGaussianDist(array, n2 * 11.0, 0.01, 0.49);
        complexGaussianDist(array, n2 * 12.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 13.0, 0.01, 0.48);
        complexGaussianDist(array, n2 * 14.0, 0.01, 0.51);
        complexGaussianDist(array, n2 * 15.0, 0.01, 0.46);
        complexGaussianDist(array, n2 * 16.0, 0.01, 0.35);
        complexGaussianDist(array, n2 * 17.0, 0.01, 0.2);
        complexGaussianDist(array, n2 * 18.0, 0.01, 0.1);
        complexGaussianDist(array, n2 * 19.0, 0.01, 0.5);
        complexGaussianDist(array, n2 * 20.0, 0.01, 0.1);
        SF2Layer layer = newLayer(sf2Soundbank, "Flute", newSimpleFFTSample(sf2Soundbank, "Flute", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_clarinet(SF2Soundbank sf2Soundbank) {
        int n = 8;
        double[] array = new double[4096 * n * 2];
        double n2 = (double)(n * 15);
        complexGaussianDist(array, n2 * 1.0, 0.001, 0.5);
        complexGaussianDist(array, n2 * 2.0, 0.001, 0.02);
        complexGaussianDist(array, n2 * 3.0, 0.001, 0.2);
        complexGaussianDist(array, n2 * 4.0, 0.01, 0.1);
        complexGaussianDist(array, n2 * 4.0, 100.0, 60.0);
        complexGaussianDist(array, n2 * 6.0, 100.0, 20.0);
        complexGaussianDist(array, n2 * 8.0, 100.0, 20.0);
        complexGaussianDist(array, n2 * 5.0, 0.001, 0.1);
        complexGaussianDist(array, n2 * 6.0, 0.001, 0.09);
        complexGaussianDist(array, n2 * 7.0, 0.001, 0.02);
        complexGaussianDist(array, n2 * 8.0, 0.005, 0.16);
        complexGaussianDist(array, n2 * 9.0, 0.005, 0.96);
        complexGaussianDist(array, n2 * 10.0, 0.01, 0.9);
        complexGaussianDist(array, n2 * 11.0, 0.08, 1.2);
        complexGaussianDist(array, n2 * 12.0, 0.08, 1.8);
        complexGaussianDist(array, n2 * 13.0, 0.08, 1.6);
        complexGaussianDist(array, n2 * 14.0, 0.08, 1.2);
        complexGaussianDist(array, n2 * 15.0, 0.08, 0.9);
        complexGaussianDist(array, n2 * 16.0, 0.08, 0.5);
        complexGaussianDist(array, n2 * 17.0, 0.08, 0.2);
        complexGaussianDist(array, n2 * 1.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 2.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 3.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 4.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 5.0, 10.0, 8.0);
        complexGaussianDist(array, n2 * 6.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 7.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 8.0, 20.0, 9.0);
        complexGaussianDist(array, n2 * 9.0, 20.0, 8.0);
        complexGaussianDist(array, n2 * 10.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 11.0, 30.0, 9.0);
        complexGaussianDist(array, n2 * 12.0, 30.0, 9.0);
        complexGaussianDist(array, n2 * 13.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 14.0, 30.0, 8.0);
        complexGaussianDist(array, n2 * 15.0, 30.0, 7.0);
        complexGaussianDist(array, n2 * 16.0, 30.0, 7.0);
        complexGaussianDist(array, n2 * 17.0, 30.0, 6.0);
        SF2Layer layer = newLayer(sf2Soundbank, "Clarinet", newSimpleFFTSample(sf2Soundbank, "Clarinet", array, n2));
        SF2Region sf2Region = (SF2Region)layer.getRegions().get(0);
        sf2Region.putInteger(54, 1);
        sf2Region.putInteger(34, -6000);
        sf2Region.putInteger(38, -1000);
        sf2Region.putInteger(36, 4000);
        sf2Region.putInteger(37, -100);
        sf2Region.putInteger(8, 9500);
        return layer;
    }
    
    public static SF2Layer new_timpani(SF2Soundbank sf2Soundbank) {
        double[] array = new double[2 * 32768];
        double n = 48.0;
        complexGaussianDist(array, n * 2.0, 0.2, 1.0);
        complexGaussianDist(array, n * 3.0, 0.2, 0.7);
        complexGaussianDist(array, n * 5.0, 10.0, 1.0);
        complexGaussianDist(array, n * 6.0, 9.0, 1.0);
        complexGaussianDist(array, n * 8.0, 15.0, 1.0);
        complexGaussianDist(array, n * 9.0, 18.0, 0.8);
        complexGaussianDist(array, n * 11.0, 21.0, 0.5);
        complexGaussianDist(array, n * 13.0, 28.0, 0.3);
        complexGaussianDist(array, n * 14.0, 22.0, 0.1);
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.5);
        double[] realPart = realPart(array);
        double n2 = (double)realPart.length;
        for (int i = 0; i < realPart.length; ++i) {
            double n3 = 1.0 - (double)i / n2;
            int n4 = i;
            realPart[n4] *= n3 * n3;
        }
        fadeUp(realPart, 40);
        int n5 = 16384;
        double[] array2 = new double[2 * n5];
        Random o = new Random(3049912L);
        for (int j = 0; j < array2.length; j += 2) {
            array2[j] = 2.0 * (o.nextDouble() - 0.5) * 0.1;
        }
        fft(array2);
        for (int k = n5 / 2; k < array2.length; ++k) {
            array2[k] = 0.0;
        }
        for (int l = 4096; l < 8192; ++l) {
            array2[l] = 1.0 - (double)(l - 4096) / 4096.0;
        }
        for (int n6 = 0; n6 < 300; ++n6) {
            double n7 = 1.0 - (double)n6 / 300.0;
            int n8 = n6;
            array2[n8] *= 1.0 + 20.0 * n7 * n7;
        }
        for (int n9 = 0; n9 < 24; ++n9) {
            array2[n9] = 0.0;
        }
        randomPhase(array2, new Random(3049912L));
        ifft(array2);
        normalize(array2, 0.9);
        double[] realPart2 = realPart(array2);
        double n10 = 1.0;
        for (int n11 = 0; n11 < realPart2.length; ++n11) {
            int n12 = n11;
            realPart2[n12] *= n10;
            n10 *= 0.9998;
        }
        for (int n13 = 0; n13 < realPart2.length; ++n13) {
            int n14 = n13;
            realPart[n14] += realPart2[n13] * 0.02;
        }
        normalize(realPart, 0.9);
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Timpani", realPart);
        SF2Layer o2 = new SF2Layer(sf2Soundbank);
        o2.setName("Timpani");
        o2.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o2);
        SF2LayerRegion o3 = new SF2LayerRegion();
        o3.putInteger(38, 12000);
        o3.putInteger(48, -100);
        o3.setSample(simpleDrumSample);
        o2.getRegions().add(o3);
        return o2;
    }
    
    public static SF2Layer new_melodic_toms(SF2Soundbank sf2Soundbank) {
        double[] array = new double[2 * 16384];
        complexGaussianDist(array, 30.0, 0.5, 1.0);
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.8);
        double[] realPart = realPart(array);
        double n = (double)realPart.length;
        for (int i = 0; i < realPart.length; ++i) {
            int n2 = i;
            realPart[n2] *= 1.0 - (double)i / n;
        }
        int n3 = 16384;
        double[] array2 = new double[2 * n3];
        Random random = new Random(3049912L);
        for (int j = 0; j < array2.length; j += 2) {
            array2[j] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array2);
        for (int k = n3 / 2; k < array2.length; ++k) {
            array2[k] = 0.0;
        }
        for (int l = 4096; l < 8192; ++l) {
            array2[l] = 1.0 - (double)(l - 4096) / 4096.0;
        }
        for (int n4 = 0; n4 < 200; ++n4) {
            double n5 = 1.0 - (double)n4 / 200.0;
            int n6 = n4;
            array2[n6] *= 1.0 + 20.0 * n5 * n5;
        }
        for (int n7 = 0; n7 < 30; ++n7) {
            array2[n7] = 0.0;
        }
        randomPhase(array2, new Random(3049912L));
        ifft(array2);
        normalize(array2, 0.9);
        double[] realPart2 = realPart(array2);
        double n8 = 1.0;
        for (int n9 = 0; n9 < realPart2.length; ++n9) {
            int n10 = n9;
            realPart2[n10] *= n8;
            n8 *= 0.9996;
        }
        for (int n11 = 0; n11 < realPart2.length; ++n11) {
            int n12 = n11;
            realPart[n12] += realPart2[n11] * 0.5;
        }
        for (int n13 = 0; n13 < 5; ++n13) {
            int n14 = n13;
            realPart[n14] *= (double)n13 / 5.0;
        }
        normalize(realPart, 0.99);
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Melodic Toms", realPart);
        simpleDrumSample.setOriginalPitch(63);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Melodic Toms");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(48, -100);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_reverse_cymbal(SF2Soundbank sf2Soundbank) {
        int n = 16384;
        double[] array = new double[2 * n];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5);
        }
        for (int j = n / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 0; k < 100; ++k) {
            array[k] = 0.0;
        }
        for (int l = 0; l < 1024; ++l) {
            array[l] = 1.0 - (double)l / 1024.0;
        }
        SF2Sample simpleFFTSample = newSimpleFFTSample(sf2Soundbank, "Reverse Cymbal", array, 100.0, 20);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Reverse Cymbal");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(34, -200);
        o2.putInteger(36, -12000);
        o2.putInteger(54, 1);
        o2.putInteger(38, -1000);
        o2.putInteger(37, 1000);
        o2.setSample(simpleFFTSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_snare_drum(SF2Soundbank sf2Soundbank) {
        double[] array = new double[2 * 16384];
        complexGaussianDist(array, 24.0, 0.5, 1.0);
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.5);
        double[] realPart = realPart(array);
        double n = (double)realPart.length;
        for (int i = 0; i < realPart.length; ++i) {
            int n2 = i;
            realPart[n2] *= 1.0 - (double)i / n;
        }
        int n3 = 16384;
        double[] array2 = new double[2 * n3];
        Random random = new Random(3049912L);
        for (int j = 0; j < array2.length; j += 2) {
            array2[j] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array2);
        for (int k = n3 / 2; k < array2.length; ++k) {
            array2[k] = 0.0;
        }
        for (int l = 4096; l < 8192; ++l) {
            array2[l] = 1.0 - (double)(l - 4096) / 4096.0;
        }
        for (int n4 = 0; n4 < 300; ++n4) {
            double n5 = 1.0 - (double)n4 / 300.0;
            int n6 = n4;
            array2[n6] *= 1.0 + 20.0 * n5 * n5;
        }
        for (int n7 = 0; n7 < 24; ++n7) {
            array2[n7] = 0.0;
        }
        randomPhase(array2, new Random(3049912L));
        ifft(array2);
        normalize(array2, 0.9);
        double[] realPart2 = realPart(array2);
        double n8 = 1.0;
        for (int n9 = 0; n9 < realPart2.length; ++n9) {
            int n10 = n9;
            realPart2[n10] *= n8;
            n8 *= 0.9998;
        }
        for (int n11 = 0; n11 < realPart2.length; ++n11) {
            int n12 = n11;
            realPart[n12] += realPart2[n11];
        }
        for (int n13 = 0; n13 < 5; ++n13) {
            int n14 = n13;
            realPart[n14] *= (double)n13 / 5.0;
        }
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Snare Drum", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Snare Drum");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(56, 0);
        o2.putInteger(48, -100);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_bass_drum(SF2Soundbank sf2Soundbank) {
        double[] array = new double[2 * 16384];
        complexGaussianDist(array, 10.0, 2.0, 1.0);
        complexGaussianDist(array, 17.2, 2.0, 1.0);
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.9);
        double[] realPart = realPart(array);
        double n = (double)realPart.length;
        for (int i = 0; i < realPart.length; ++i) {
            int n2 = i;
            realPart[n2] *= 1.0 - (double)i / n;
        }
        int n3 = 4096;
        double[] array2 = new double[2 * n3];
        Random random = new Random(3049912L);
        for (int j = 0; j < array2.length; j += 2) {
            array2[j] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array2);
        for (int k = n3 / 2; k < array2.length; ++k) {
            array2[k] = 0.0;
        }
        for (int l = 1024; l < 2048; ++l) {
            array2[l] = 1.0 - (double)(l - 1024) / 1024.0;
        }
        for (int n4 = 0; n4 < 512; ++n4) {
            array2[n4] = (double)(10 * n4) / 512.0;
        }
        for (int n5 = 0; n5 < 10; ++n5) {
            array2[n5] = 0.0;
        }
        randomPhase(array2, new Random(3049912L));
        ifft(array2);
        normalize(array2, 0.9);
        double[] realPart2 = realPart(array2);
        double n6 = 1.0;
        for (int n7 = 0; n7 < realPart2.length; ++n7) {
            int n8 = n7;
            realPart2[n8] *= n6;
            n6 *= 0.999;
        }
        for (int n9 = 0; n9 < realPart2.length; ++n9) {
            int n10 = n9;
            realPart[n10] += realPart2[n9] * 0.5;
        }
        for (int n11 = 0; n11 < 5; ++n11) {
            int n12 = n11;
            realPart[n12] *= (double)n11 / 5.0;
        }
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Bass Drum", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Bass Drum");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(56, 0);
        o2.putInteger(48, -100);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_tom(SF2Soundbank sf2Soundbank) {
        double[] array = new double[2 * 16384];
        complexGaussianDist(array, 30.0, 0.5, 1.0);
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.8);
        double[] realPart = realPart(array);
        double n = (double)realPart.length;
        for (int i = 0; i < realPart.length; ++i) {
            int n2 = i;
            realPart[n2] *= 1.0 - (double)i / n;
        }
        int n3 = 16384;
        double[] array2 = new double[2 * n3];
        Random random = new Random(3049912L);
        for (int j = 0; j < array2.length; j += 2) {
            array2[j] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array2);
        for (int k = n3 / 2; k < array2.length; ++k) {
            array2[k] = 0.0;
        }
        for (int l = 4096; l < 8192; ++l) {
            array2[l] = 1.0 - (double)(l - 4096) / 4096.0;
        }
        for (int n4 = 0; n4 < 200; ++n4) {
            double n5 = 1.0 - (double)n4 / 200.0;
            int n6 = n4;
            array2[n6] *= 1.0 + 20.0 * n5 * n5;
        }
        for (int n7 = 0; n7 < 30; ++n7) {
            array2[n7] = 0.0;
        }
        randomPhase(array2, new Random(3049912L));
        ifft(array2);
        normalize(array2, 0.9);
        double[] realPart2 = realPart(array2);
        double n8 = 1.0;
        for (int n9 = 0; n9 < realPart2.length; ++n9) {
            int n10 = n9;
            realPart2[n10] *= n8;
            n8 *= 0.9996;
        }
        for (int n11 = 0; n11 < realPart2.length; ++n11) {
            int n12 = n11;
            realPart[n12] += realPart2[n11] * 0.5;
        }
        for (int n13 = 0; n13 < 5; ++n13) {
            int n14 = n13;
            realPart[n14] *= (double)n13 / 5.0;
        }
        normalize(realPart, 0.99);
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Tom", realPart);
        simpleDrumSample.setOriginalPitch(50);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Tom");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(48, -100);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_closed_hihat(SF2Soundbank sf2Soundbank) {
        int n = 16384;
        double[] array = new double[2 * n];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array);
        for (int j = n / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 4096; k < 8192; ++k) {
            array[k] = 1.0 - (double)(k - 4096) / 4096.0;
        }
        for (int l = 0; l < 2048; ++l) {
            array[l] = 0.2 + 0.8 * ((double)l / 2048.0);
        }
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.9);
        double[] realPart = realPart(array);
        double n2 = 1.0;
        for (int n3 = 0; n3 < realPart.length; ++n3) {
            int n4 = n3;
            realPart[n4] *= n2;
            n2 *= 0.9996;
        }
        for (int n5 = 0; n5 < 5; ++n5) {
            int n6 = n5;
            realPart[n6] *= (double)n5 / 5.0;
        }
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Closed Hi-Hat", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Closed Hi-Hat");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(56, 0);
        o2.putInteger(57, 1);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_open_hihat(SF2Soundbank sf2Soundbank) {
        int n = 16384;
        double[] array = new double[2 * n];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5);
        }
        for (int j = n / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 0; k < 200; ++k) {
            array[k] = 0.0;
        }
        for (int l = 0; l < 8192; ++l) {
            array[l] = (double)l / 8192.0;
        }
        SF2Sample simpleFFTSample = newSimpleFFTSample(sf2Soundbank, "Open Hi-Hat", array, 1000.0, 5);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Open Hi-Hat");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(36, 1500);
        o2.putInteger(54, 1);
        o2.putInteger(38, 1500);
        o2.putInteger(37, 1000);
        o2.putInteger(56, 0);
        o2.putInteger(57, 1);
        o2.setSample(simpleFFTSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_crash_cymbal(SF2Soundbank sf2Soundbank) {
        int n = 16384;
        double[] array = new double[2 * n];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5);
        }
        for (int j = n / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 0; k < 100; ++k) {
            array[k] = 0.0;
        }
        for (int l = 0; l < 1024; ++l) {
            array[l] = (double)l / 1024.0;
        }
        SF2Sample simpleFFTSample = newSimpleFFTSample(sf2Soundbank, "Crash Cymbal", array, 1000.0, 5);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Crash Cymbal");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(36, 1800);
        o2.putInteger(54, 1);
        o2.putInteger(38, 1800);
        o2.putInteger(37, 1000);
        o2.putInteger(56, 0);
        o2.setSample(simpleFFTSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Layer new_side_stick(SF2Soundbank sf2Soundbank) {
        int n = 16384;
        double[] array = new double[2 * n];
        Random random = new Random(3049912L);
        for (int i = 0; i < array.length; i += 2) {
            array[i] = 2.0 * (random.nextDouble() - 0.5) * 0.1;
        }
        fft(array);
        for (int j = n / 2; j < array.length; ++j) {
            array[j] = 0.0;
        }
        for (int k = 4096; k < 8192; ++k) {
            array[k] = 1.0 - (double)(k - 4096) / 4096.0;
        }
        for (int l = 0; l < 200; ++l) {
            double n2 = 1.0 - (double)l / 200.0;
            int n3 = l;
            array[n3] *= 1.0 + 20.0 * n2 * n2;
        }
        for (int n4 = 0; n4 < 30; ++n4) {
            array[n4] = 0.0;
        }
        randomPhase(array, new Random(3049912L));
        ifft(array);
        normalize(array, 0.9);
        double[] realPart = realPart(array);
        double n5 = 1.0;
        for (int n6 = 0; n6 < realPart.length; ++n6) {
            int n7 = n6;
            realPart[n7] *= n5;
            n5 *= 0.9996;
        }
        for (int n8 = 0; n8 < 10; ++n8) {
            int n9 = n8;
            realPart[n9] *= (double)n8 / 10.0;
        }
        SF2Sample simpleDrumSample = newSimpleDrumSample(sf2Soundbank, "Side Stick", realPart);
        SF2Layer o = new SF2Layer(sf2Soundbank);
        o.setName("Side Stick");
        o.setGlobalZone(new SF2GlobalRegion());
        sf2Soundbank.addResource(o);
        SF2LayerRegion o2 = new SF2LayerRegion();
        o2.putInteger(38, 12000);
        o2.putInteger(56, 0);
        o2.putInteger(48, -50);
        o2.setSample(simpleDrumSample);
        o.getRegions().add(o2);
        return o;
    }
    
    public static SF2Sample newSimpleFFTSample(SF2Soundbank sf2Soundbank, String s, double[] array, double n) {
        return newSimpleFFTSample(sf2Soundbank, s, array, n, 10);
    }
    
    public static SF2Sample newSimpleFFTSample(SF2Soundbank sf2Soundbank, String name, double[] realPart, double n, int n2) {
        int n3 = realPart.length / 2;
        AudioFormat audioFormat = new AudioFormat(44100.0f, 16, 1, true, false);
        double n4 = n / (double)n3 * (double)audioFormat.getSampleRate() * 0.5;
        randomPhase(realPart);
        ifft(realPart);
        realPart = realPart(realPart);
        normalize(realPart, 0.9);
        float[] float1 = toFloat(realPart);
        float[] loopExtend = loopExtend(float1, float1.length + 512);
        fadeUp(loopExtend, n2);
        byte[] bytes = toBytes(loopExtend, audioFormat);
        SF2Sample sf2Sample = new SF2Sample(sf2Soundbank);
        sf2Sample.setName(name);
        sf2Sample.setData(bytes);
        sf2Sample.setStartLoop(256L);
        sf2Sample.setEndLoop((long)(n3 + 256));
        sf2Sample.setSampleRate((long)audioFormat.getSampleRate());
        double n5 = 81.0 + 12.0 * Math.log(n4 / 440.0) / Math.log(2.0);
        sf2Sample.setOriginalPitch((int)n5);
        sf2Sample.setPitchCorrection((byte)(int)(-(n5 - (double)(int)n5) * 100.0));
        sf2Soundbank.addResource(sf2Sample);
        return sf2Sample;
    }
    
    public static SF2Sample newSimpleFFTSample_dist(SF2Soundbank sf2Soundbank, String name, double[] realPart, double n, double n2) {
        int n3 = realPart.length / 2;
        AudioFormat audioFormat = new AudioFormat(44100.0f, 16, 1, true, false);
        double n4 = n / (double)n3 * (double)audioFormat.getSampleRate() * 0.5;
        randomPhase(realPart);
        ifft(realPart);
        realPart = realPart(realPart);
        for (int i = 0; i < realPart.length; ++i) {
            realPart[i] = (1.0 - Math.exp(-Math.abs(realPart[i] * n2))) * Math.signum(realPart[i]);
        }
        normalize(realPart, 0.9);
        float[] float1 = toFloat(realPart);
        float[] loopExtend = loopExtend(float1, float1.length + 512);
        fadeUp(loopExtend, 80);
        byte[] bytes = toBytes(loopExtend, audioFormat);
        SF2Sample sf2Sample = new SF2Sample(sf2Soundbank);
        sf2Sample.setName(name);
        sf2Sample.setData(bytes);
        sf2Sample.setStartLoop(256L);
        sf2Sample.setEndLoop((long)(n3 + 256));
        sf2Sample.setSampleRate((long)audioFormat.getSampleRate());
        double n5 = 81.0 + 12.0 * Math.log(n4 / 440.0) / Math.log(2.0);
        sf2Sample.setOriginalPitch((int)n5);
        sf2Sample.setPitchCorrection((byte)(int)(-(n5 - (double)(int)n5) * 100.0));
        sf2Soundbank.addResource(sf2Sample);
        return sf2Sample;
    }
    
    public static SF2Sample newSimpleDrumSample(SF2Soundbank sf2Soundbank, String name, double[] array) {
        int length = array.length;
        AudioFormat audioFormat = new AudioFormat(44100.0f, 16, 1, true, false);
        byte[] bytes = toBytes(toFloat(realPart(array)), audioFormat);
        SF2Sample sf2Sample = new SF2Sample(sf2Soundbank);
        sf2Sample.setName(name);
        sf2Sample.setData(bytes);
        sf2Sample.setStartLoop(256L);
        sf2Sample.setEndLoop((long)(length + 256));
        sf2Sample.setSampleRate((long)audioFormat.getSampleRate());
        sf2Sample.setOriginalPitch(60);
        sf2Soundbank.addResource(sf2Sample);
        return sf2Sample;
    }
    
    public static SF2Layer newLayer(SF2Soundbank sf2Soundbank, String name, SF2Sample sample) {
        SF2LayerRegion sf2LayerRegion = new SF2LayerRegion();
        sf2LayerRegion.setSample(sample);
        SF2Layer sf2Layer = new SF2Layer(sf2Soundbank);
        sf2Layer.setName(name);
        sf2Layer.getRegions().add(sf2LayerRegion);
        sf2Soundbank.addResource(sf2Layer);
        return sf2Layer;
    }
    
    public static SF2Instrument newInstrument(SF2Soundbank sf2Soundbank, String name, Patch patch, SF2Layer... array) {
        SF2Instrument sf2Instrument = new SF2Instrument(sf2Soundbank);
        sf2Instrument.setPatch(patch);
        sf2Instrument.setName(name);
        sf2Soundbank.addInstrument(sf2Instrument);
        for (int i = 0; i < array.length; ++i) {
            SF2InstrumentRegion o = new SF2InstrumentRegion();
            o.setLayer(array[i]);
            sf2Instrument.getRegions().add(o);
        }
        return sf2Instrument;
    }
    
    public static void ifft(double[] array) {
        new FFT(array.length / 2, 1).transform(array);
    }
    
    public static void fft(double[] array) {
        new FFT(array.length / 2, -1).transform(array);
    }
    
    public static void complexGaussianDist(double[] array, double n, double n2, double n3) {
        for (int i = 0; i < array.length / 4; ++i) {
            int n4 = i * 2;
            array[n4] += n3 * (1.0 / (n2 * Math.sqrt(6.283185307179586)) * Math.exp(-0.5 * Math.pow(((double)i - n) / n2, 2.0)));
        }
    }
    
    public static void randomPhase(double[] array) {
        for (int i = 0; i < array.length; i += 2) {
            double n = Math.random() * 2.0 * 3.141592653589793;
            double n2 = array[i];
            array[i] = Math.sin(n) * n2;
            array[i + 1] = Math.cos(n) * n2;
        }
    }
    
    public static void randomPhase(double[] array, Random random) {
        for (int i = 0; i < array.length; i += 2) {
            double n = random.nextDouble() * 2.0 * 3.141592653589793;
            double n2 = array[i];
            array[i] = Math.sin(n) * n2;
            array[i + 1] = Math.cos(n) * n2;
        }
    }
    
    public static void normalize(double[] array, double n) {
        double n2 = 0.0;
        for (int i = 0; i < array.length; ++i) {
            if (array[i] > n2) {
                n2 = array[i];
            }
            if (-array[i] > n2) {
                n2 = -array[i];
            }
        }
        if (n2 == 0.0) {
            return;
        }
        double n3 = n / n2;
        for (int j = 0; j < array.length; ++j) {
            int n4 = j;
            array[n4] *= n3;
        }
        return;
    }
    
    public static void normalize(float[] array, double n) {
        double n2 = 0.5;
        for (int i = 0; i < array.length; ++i) {
            if ((double)array[i * 2] > n2) {
                n2 = (double)array[i * 2];
            }
            if ((double)(-array[i * 2]) > n2) {
                n2 = (double)(-array[i * 2]);
            }
        }
        double n3 = n / n2;
        for (int j = 0; j < array.length; ++j) {
            int n4 = j * 2;
            array[n4] = (float)((double)array[n4] * n3);
        }
    }
    
    public static double[] realPart(double[] array) {
        double[] array2 = new double[array.length / 2];
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = array[i * 2];
        }
        return array2;
    }
    
    public static double[] imgPart(double[] array) {
        double[] array2 = new double[array.length / 2];
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = array[i * 2];
        }
        return array2;
    }
    
    public static float[] toFloat(double[] array) {
        float[] array2 = new float[array.length];
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = (float)array[i];
        }
        return array2;
    }
    
    public static byte[] toBytes(float[] array, AudioFormat audioFormat) {
        return AudioFloatConverter.getConverter(audioFormat).toByteArray(array, new byte[array.length * audioFormat.getFrameSize()]);
    }
    
    public static void fadeUp(double[] array, int n) {
        double n2 = (double)n;
        for (int i = 0; i < n; ++i) {
            int n3 = i;
            array[n3] *= (double)i / n2;
        }
    }
    
    public static void fadeUp(float[] array, int n) {
        double n2 = (double)n;
        for (int i = 0; i < n; ++i) {
            int n3 = i;
            array[n3] = (float)((double)array[n3] * ((double)i / n2));
        }
    }
    
    public static double[] loopExtend(double[] array, int n) {
        double[] array2 = new double[n];
        int length = array.length;
        int n2 = 0;
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = array[n2];
            if (++n2 == length) {
                n2 = 0;
            }
        }
        return array2;
    }
    
    public static float[] loopExtend(float[] array, int n) {
        float[] array2 = new float[n];
        int length = array.length;
        int n2 = 0;
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = array[n2];
            if (++n2 == length) {
                n2 = 0;
            }
        }
        return array2;
    }
    
    static {
        general_midi_instruments = new String[] { "Acoustic Grand Piano", "Bright Acoustic Piano", "Electric Grand Piano", "Honky-tonk Piano", "Electric Piano 1", "Electric Piano 2", "Harpsichord", "Clavi", "Celesta", "Glockenspiel", "Music Box", "Vibraphone", "Marimba", "Xylophone", "Tubular Bells", "Dulcimer", "Drawbar Organ", "Percussive Organ", "Rock Organ", "Church Organ", "Reed Organ", "Accordion", "Harmonica", "Tango Accordion", "Acoustic Guitar (nylon)", "Acoustic Guitar (steel)", "Electric Guitar (jazz)", "Electric Guitar (clean)", "Electric Guitar (muted)", "Overdriven Guitar", "Distortion Guitar", "Guitar harmonics", "Acoustic Bass", "Electric Bass (finger)", "Electric Bass (pick)", "Fretless Bass", "Slap Bass 1", "Slap Bass 2", "Synth Bass 1", "Synth Bass 2", "Violin", "Viola", "Cello", "Contrabass", "Tremolo Strings", "Pizzicato Strings", "Orchestral Harp", "Timpani", "String Ensemble 1", "String Ensemble 2", "SynthStrings 1", "SynthStrings 2", "Choir Aahs", "Voice Oohs", "Synth Voice", "Orchestra Hit", "Trumpet", "Trombone", "Tuba", "Muted Trumpet", "French Horn", "Brass Section", "SynthBrass 1", "SynthBrass 2", "Soprano Sax", "Alto Sax", "Tenor Sax", "Baritone Sax", "Oboe", "English Horn", "Bassoon", "Clarinet", "Piccolo", "Flute", "Recorder", "Pan Flute", "Blown Bottle", "Shakuhachi", "Whistle", "Ocarina", "Lead 1 (square)", "Lead 2 (sawtooth)", "Lead 3 (calliope)", "Lead 4 (chiff)", "Lead 5 (charang)", "Lead 6 (voice)", "Lead 7 (fifths)", "Lead 8 (bass + lead)", "Pad 1 (new age)", "Pad 2 (warm)", "Pad 3 (polysynth)", "Pad 4 (choir)", "Pad 5 (bowed)", "Pad 6 (metallic)", "Pad 7 (halo)", "Pad 8 (sweep)", "FX 1 (rain)", "FX 2 (soundtrack)", "FX 3 (crystal)", "FX 4 (atmosphere)", "FX 5 (brightness)", "FX 6 (goblins)", "FX 7 (echoes)", "FX 8 (sci-fi)", "Sitar", "Banjo", "Shamisen", "Koto", "Kalimba", "Bag pipe", "Fiddle", "Shanai", "Tinkle Bell", "Agogo", "Steel Drums", "Woodblock", "Taiko Drum", "Melodic Tom", "Synth Drum", "Reverse Cymbal", "Guitar Fret Noise", "Breath Noise", "Seashore", "Bird Tweet", "Telephone Ring", "Helicopter", "Applause", "Gunshot" };
    }
}
